<template>
  <v-row>
    <v-col cols="12">
      <file-pond
        ref="pond"
        :files="filesFilePond"
        :instant-upload="instant"
        :allow-drop="true"
        :allow-multiple="false"
        :server="{ process, revert, restore, load, fetch, remove }"
        :max-files="1"
        :max-parallel-uploads="1"
        :name="name"
        data-cy="filepond"
        class-name="filepond"
        :accepted-file-types="acceptedFileTypes"
        :label-idle="$t('uploadfile')"
        @updatefiles="updatefiles"
        @addfile="changefiles"
      />
    </v-col>
  </v-row>
</template>

<script>
/* eslint-disable @typescript-eslint/no-unused-vars */
// import uuid from 'uuid'
import _ from 'lodash'
import async from 'async'
import Vue from 'vue'

import vueFilePond from 'vue-filepond'
import FilePondPluginImageCrop from 'filepond-plugin-image-crop'
import FilePondPluginFileRename from 'filepond-plugin-file-rename'
import FilePondPluginImageResize from 'filepond-plugin-image-resize'
import FilePondPluginImageTransform from 'filepond-plugin-image-transform'
import FilePondPluginImageExifOrientation from 'filepond-plugin-image-exif-orientation'
import FilePondPluginImagePreview from 'filepond-plugin-image-preview/dist/filepond-plugin-image-preview.esm.js'
import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type/dist/filepond-plugin-file-validate-type.esm.js'

import 'filepond/dist/filepond.min.css'
import 'filepond-plugin-image-preview/dist/filepond-plugin-image-preview.min.css'

const FilePond = vueFilePond(
  FilePondPluginFileValidateType,
  FilePondPluginImageExifOrientation,
  FilePondPluginImagePreview,
  FilePondPluginImageCrop,
  FilePondPluginImageResize,
  FilePondPluginImageTransform,
  FilePondPluginFileRename
)

export default Vue.extend({
  components: {
    FilePond,
  },
  props: {
    instant: {
      type: Boolean,
      default: false,
    },
    files: {
      type: Array,
      required: false,
      default: () => [],
    },
    folder: {
      type: String,
      default: '',
      required: true,
    },
    nameFile: {
      type: String,
      default: '',
      required: false,
    },
    acceptedFileTypes: {
      type: String,
      default: 'image/png',
      required: true,
    },
    name: {
      type: String,
      default: 'filepond',
    },
  },
  data() {
    return {
      filesUrl: [],
      filesToRemove: [],
      filesNames: [],
    }
  },
  computed: {
    filesFilePond() {
      const images = []
      if (this.files && this.files.length > 0) {
        this.files.forEach((element) => {
          images.push({
            source: element,
            options: {
              type: 'local',
            },
          })
        })
      }
      return images
    },
  },
  methods: {
    load(source, load, error) {
      const xhr = new XMLHttpRequest()
      xhr.responseType = 'blob'
      xhr.onload = function () {
        if (xhr.status === 200) {
          load(xhr.response)
        } else {
          error('Error obteniendo el archivo')
        }
      }
      xhr.open('GET', source)
      xhr.send()
    },
    process(fieldName, file, metadata, load, error, progress, abort) {
      const self = this
      const fileRef = this.$fire.storage
        .ref()
        .child(
          `${this.folder}/${this.$fire.auth.currentUser.uid}/${
            this.nameFile ? this.nameFile : file.name
          }`
        )
      progress(true, 0, 1024)
      const uploadTask = fileRef.put(file)
      uploadTask.on(
        'state_changed',
        function (snapshot) {
          progress(true, snapshot.bytesTransferred, snapshot.totalBytes)
        },
        function (err) {
          console.error(err)
        },
        function () {
          uploadTask.snapshot.ref
            .getDownloadURL()
            .then((downloadURL) => {
              self.filesFilePond.push({
                source: downloadURL,
                options: {
                  type: 'local',
                },
              })
              self.filesUrl.unshift(downloadURL)
              load(downloadURL)
            })
            .catch((err) => {
              console.error(err)
            })
        }
      )
      return {
        abort: () => {
          uploadTask.cancel()
          abort()
        },
      }
    },
    revert() {
      // ---
    },
    fetch() {
      // ---
    },
    restore() {
      // ---
    },
    remove(source, load) {
      const filePath = decodeURIComponent(source.split('?')[0].split('/o/')[1])
      this.filesToRemove.push({
        id: _.find(this.$refs.pond.getFiles(), ['source', source]).id,
        filePath,
      })
      load()
    },
    getFiles() {
      return this.$refs.pond.getFiles()
    },
    changefiles() {
      const files = this.$refs.pond.getFiles()
      this.$emit('change', files)
    },
    uploadFiles() {
      const self = this
      return new Promise((resolve, reject) => {
        const filesToUpload = []
        this.$refs.pond.getFiles().forEach((element) => {
          if (element.origin === 1) {
            this.filesNames.push(element.filename)
            filesToUpload.push(element.id)
          }
        })
        if (filesToUpload.length > 0) {
          this.$refs.pond
            .processFiles(filesToUpload)
            .then(() => {
              self.$emit(
                'change',
                self.filesUrl && self.filesUrl.length > 0
                  ? self.filesUrl
                  : null,
                self.filesNames && self.filesNames.length > 0
                  ? self.filesNames
                  : null
              )
              resolve(true)
            })
            .catch((err) => {
              reject(err)
            })
        } else {
          resolve(true)
        }
      })
    },
    deleteFiles() {
      const self = this
      return new Promise((resolve, reject) => {
        if (this.filesToRemove.length > 0) {
          async.each(
            this.filesToRemove,
            function (element, callback) {
              const fileRef = this.$fire.storage.ref().child(element.filePath)
              fileRef
                .delete()
                .then(function () {
                  _.remove(self.filesUrl, (el) => {
                    return _.includes(el, element.filePath.split('/')[1])
                  })
                  _.remove(self.filesFilePond, (el) => {
                    return _.includes(el.source, element.filePath.split('/')[1])
                  })
                  self.$refs.pond.removeFile(element.id)
                  callback()
                })
                .catch(function (err) {
                  console.error(err)
                })
            },
            function (err) {
              if (err) {
                console.error(err)
                reject(err)
              } else {
                self.filesToRemove = []
                self.$emit('change', self.filesUrl)
                resolve(true)
              }
            }
          )
        } else {
          resolve(true)
        }
      })
    },
    updatefiles() {
      this.$emit('total', this.$refs.pond.getFiles().length)
    },
    removeFile() {
      this.$refs.pond.removeFile()
    },
    hexToRgbA(hex, alpha) {
      let c
      if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)) {
        c = hex.substring(1).split('')
        if (c.length === 3) {
          c = [c[0], c[0], c[1], c[1], c[2], c[2]]
        }
        c = '0x' + c.join('')
        return (
          'rgba(' +
          [(c >> 16) & 255, (c >> 8) & 255, c & 255].join(',') +
          ',' +
          alpha +
          ') !important'
        )
      }
      throw new Error('Bad Hex')
    },
  },
})
</script>

<style>
.profile .filepond--root {
  width: 100px;
  margin: 0 auto;
}
.filepond--action-process-item {
  visibility: hidden;
  display: none;
}
</style>
